/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudAntiddosV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#floating_ip_address DataOpentelekomcloudAntiddosV1#floating_ip_address}
    */
    readonly floatingIpAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#floating_ip_id DataOpentelekomcloudAntiddosV1#floating_ip_id}
    */
    readonly floatingIpId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#id DataOpentelekomcloudAntiddosV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#region DataOpentelekomcloudAntiddosV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#status DataOpentelekomcloudAntiddosV1#status}
    */
    readonly status?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1 opentelekomcloud_antiddos_v1}
*/
export declare class DataOpentelekomcloudAntiddosV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opentelekomcloud_antiddos_v1";
    /**
    * Generates CDKTF code for importing a DataOpentelekomcloudAntiddosV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpentelekomcloudAntiddosV1 to import
    * @param importFromId The id of the existing DataOpentelekomcloudAntiddosV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpentelekomcloudAntiddosV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/antiddos_v1 opentelekomcloud_antiddos_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudAntiddosV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudAntiddosV1Config);
    get bpsAttack(): number[];
    get bpsIn(): number[];
    get endTime(): number[];
    private _floatingIpAddress?;
    get floatingIpAddress(): string;
    set floatingIpAddress(value: string);
    resetFloatingIpAddress(): void;
    get floatingIpAddressInput(): string | undefined;
    private _floatingIpId?;
    get floatingIpId(): string;
    set floatingIpId(value: string);
    resetFloatingIpId(): void;
    get floatingIpIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get networkType(): string;
    get periodStart(): number[];
    get ppsAttack(): number[];
    get ppsIn(): number[];
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    get startTime(): number[];
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
    get totalBps(): number[];
    get totalPps(): number[];
    get trafficCleaningStatus(): number[];
    get triggerBps(): number[];
    get triggerHttpPps(): number[];
    get triggerPps(): number[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
