/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudApigwGatewayFeaturesV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2#gateway_id DataOpentelekomcloudApigwGatewayFeaturesV2#gateway_id}
    */
    readonly gatewayId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2#id DataOpentelekomcloudApigwGatewayFeaturesV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2#name DataOpentelekomcloudApigwGatewayFeaturesV2#name}
    */
    readonly name?: string;
}
export interface DataOpentelekomcloudApigwGatewayFeaturesV2Features {
}
export declare function dataOpentelekomcloudApigwGatewayFeaturesV2FeaturesToTerraform(struct?: DataOpentelekomcloudApigwGatewayFeaturesV2Features): any;
export declare function dataOpentelekomcloudApigwGatewayFeaturesV2FeaturesToHclTerraform(struct?: DataOpentelekomcloudApigwGatewayFeaturesV2Features): any;
export declare class DataOpentelekomcloudApigwGatewayFeaturesV2FeaturesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpentelekomcloudApigwGatewayFeaturesV2Features | undefined;
    set internalValue(value: DataOpentelekomcloudApigwGatewayFeaturesV2Features | undefined);
    get config(): string;
    get enabled(): cdktf.IResolvable;
    get id(): string;
    get name(): string;
    get updatedAt(): string;
}
export declare class DataOpentelekomcloudApigwGatewayFeaturesV2FeaturesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpentelekomcloudApigwGatewayFeaturesV2FeaturesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2 opentelekomcloud_apigw_gateway_features_v2}
*/
export declare class DataOpentelekomcloudApigwGatewayFeaturesV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opentelekomcloud_apigw_gateway_features_v2";
    /**
    * Generates CDKTF code for importing a DataOpentelekomcloudApigwGatewayFeaturesV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpentelekomcloudApigwGatewayFeaturesV2 to import
    * @param importFromId The id of the existing DataOpentelekomcloudApigwGatewayFeaturesV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpentelekomcloudApigwGatewayFeaturesV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.33/docs/data-sources/apigw_gateway_features_v2 opentelekomcloud_apigw_gateway_features_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudApigwGatewayFeaturesV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpentelekomcloudApigwGatewayFeaturesV2Config);
    private _features;
    get features(): DataOpentelekomcloudApigwGatewayFeaturesV2FeaturesList;
    private _gatewayId?;
    get gatewayId(): string;
    set gatewayId(value: string);
    get gatewayIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get region(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
